-- USER SQL
DROP USER SCOLPEDA CASCADE;
CREATE USER SCOLPEDA IDENTIFIED BY bdlmmdescolpeda
DEFAULT TABLESPACE DATA_GRHUM TEMPORARY TABLESPACE TEMP quota unlimited on DATA_GRHUM quota unlimited on INDX_GRHUM;
GRANT CREATE SESSION TO SCOLPEDA;


------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------- TABLES -----------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------

---------- 	TABLES PARAMETRAGE ------------
CREATE TABLE SCOLPEDA.PAYS (
  	ID NUMBER(38) NOT NULL,
  	NOM VARCHAR2(255) NOT NULL,
  	CODE NUMBER,
  	PRIMARY KEY (ID)
);
CREATE SEQUENCE SCOLPEDA.PAYS_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.LANGUE (
  	ID NUMBER(38) NOT NULL,
  	CODE VARCHAR2(255) NOT NULL,
  	PAYS_ID NUMBER(38) NOT NULL,
  	LIBELLE VARCHAR2(255),
  	PRIMARY KEY (ID),
  	CONSTRAINT FK_SCOLPEDALANGUE_PAYSID FOREIGN KEY (PAYS_ID) REFERENCES SCOLPEDA.PAYS (ID)
);
CREATE SEQUENCE SCOLPEDA.LANGUE_SEQ START WITH 1;


---------- 	PARTIE BASSE ------------
CREATE TABLE SCOLPEDA.TYPE_COMPOSANT (
  	ID NUMBER(38) NOT NULL,
  	NOM VARCHAR2(255) NOT NULL,
  	PRIMARY KEY (ID)
);
CREATE SEQUENCE SCOLPEDA.TYPE_COMPOSANT_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.COMPOSANT (
  	ID NUMBER(38) NOT NULL,
  	CODE VARCHAR2(255) NOT NULL,
  	LIBELLE VARCHAR2(255) NOT NULL,
  	TYPE_COMPOSANT_ID NUMBER(38) NOT NULL,
  	PRIMARY KEY (ID),
  	CONSTRAINT FK_SCOLPEDACOMPOSANT_TCOMPID FOREIGN KEY (TYPE_COMPOSANT_ID) REFERENCES SCOLPEDA.TYPE_COMPOSANT (ID)
);
CREATE SEQUENCE SCOLPEDA.COMPOSANT_SEQ START WITH 8;


CREATE TABLE SCOLPEDA.TYPE_LIEN (
  	ID NUMBER(38) NOT NULL,
  	NOM VARCHAR2(255) NOT NULL,
  	PRIMARY KEY (ID)
);
CREATE SEQUENCE SCOLPEDA.TYPE_LIEN_SEQ START WITH 2;


CREATE TABLE SCOLPEDA.LIEN (
  	ID NUMBER(38) NOT NULL,
  	PARENT_ID NUMBER(38) NOT NULL,
  	CHILD_ID NUMBER(38) NOT NULL,
  	TYPE_LIEN_ID NUMBER(38) NOT NULL,
  	PRIMARY KEY (ID),
  	CONSTRAINT FK_SCOLPEDALIEN_PARENTID FOREIGN KEY (PARENT_ID) REFERENCES SCOLPEDA.COMPOSANT (ID),
  	CONSTRAINT FK_SCOLPEDALIEN_CHILDID FOREIGN KEY (CHILD_ID) REFERENCES SCOLPEDA.COMPOSANT (ID),
  	CONSTRAINT FK_SCOLPEDALIEN_TYPELIENID FOREIGN KEY (TYPE_LIEN_ID) REFERENCES SCOLPEDA.TYPE_LIEN (ID)
);
CREATE SEQUENCE SCOLPEDA.LIEN_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.REGLE_LIAISON (
  	ID NUMBER(38) NOT NULL,
  	ALLOWED_PARENT_ID NUMBER(38) NOT NULL,
  	ALLOWED_CHILD_ID NUMBER(38) NOT NULL,
  	TYPE_LIEN_ID NUMBER(38) NOT NULL,
  	PRIMARY KEY (ID),
  	CONSTRAINT FK_SCOLPEDAREGLELIAISON_APARID FOREIGN KEY (ALLOWED_PARENT_ID) REFERENCES SCOLPEDA.TYPE_COMPOSANT (ID),
  	CONSTRAINT FK_SCOLPEDAREGLELIAISON_ACHID FOREIGN KEY (ALLOWED_CHILD_ID) REFERENCES SCOLPEDA.TYPE_COMPOSANT (ID),
  	CONSTRAINT FK_SCOLPEDAREGLELIAISON_TLIEID FOREIGN KEY (TYPE_LIEN_ID) REFERENCES SCOLPEDA.TYPE_LIEN (ID)
);
CREATE SEQUENCE SCOLPEDA.REGLE_LIAISON_SEQ START WITH 13;


CREATE TABLE SCOLPEDA.PERIODE (
    ID NUMBER(38) NOT NULL,
    PRIMARY KEY ( ID )
);
CREATE SEQUENCE SCOLPEDA.PERIODE_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.PARCOURS (
    ID NUMBER(38) NOT NULL,
    COEFFICIENT NUMBER,
    SEUIL NUMBER,
    ORDRE NUMBER,
    TYPE VARCHAR2(255),
    NB_INSCRITS NUMBER DEFAULT 0,
    OBLIGATOIRE NUMBER DEFAULT 0 NOT NULL,
    RESPONSABLE_ID NUMBER,
    PRIMARY KEY ( ID )
);
CREATE SEQUENCE SCOLPEDA.PARCOURS_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.REGLEMENT (
  	ID NUMBER(38) NOT NULL,
  	REGLEMENT VARCHAR2(255) NOT NULL,
  	PARCOURS_ID NUMBER(38) NOT NULL,
  	PAYS_ID NUMBER(38) NOT NULL,
  	LANGUE_ID NUMBER(38) NOT NULL,
  	PRIMARY KEY (ID),
  	CONSTRAINT FK_SCOLPEDAREGLEMENT_PARCOURID FOREIGN KEY (PARCOURS_ID) REFERENCES SCOLPEDA.PARCOURS (ID),
  	CONSTRAINT FK_SCOLPEDAREGLEMENT_PAYSID FOREIGN KEY (PAYS_ID) REFERENCES SCOLPEDA.PAYS (ID),
  	CONSTRAINT FK_SCOLPEDAREGLEMENT_LANGUEID FOREIGN KEY (LANGUE_ID) REFERENCES SCOLPEDA.LANGUE (ID)
);
CREATE SEQUENCE SCOLPEDA.REGLEMENT_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.RESPONSABLE (
  	ID NUMBER(38) NOT NULL,
  	NOM VARCHAR2(255) NOT NULL,
  	PRENOM VARCHAR2(255) NOT NULL,
  	FONCTION VARCHAR2(255),
  	PRIMARY KEY (ID)
);
CREATE SEQUENCE SCOLPEDA.RESPONSABLE_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.REGROUPEMENT (
    ID NUMBER(38) NOT NULL,
    DOMAINE VARCHAR2(255),
    ACTIVE_ADMISSION NUMBER DEFAULT 0,
    FORMULE_ADMISSION VARCHAR2(255),
    SEUIL_ADMISSION NUMBER,
    ACTIVE_COMPENSATION NUMBER DEFAULT 0,
    FORMULE_COMPENSATION VARCHAR2(255),
    SEUIL_COMPENSATION NUMBER,
    CHOIX_MIN NUMBER,
    CHOIX_MAX NUMBER,
    OBLIGATOIRE NUMBER DEFAULT 0,
    PRIMARY KEY ( ID )
);
CREATE SEQUENCE SCOLPEDA.REGROUPEMENT_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.UE (
    ID NUMBER(38) NOT NULL,
    PRIMARY KEY ( ID )
);
CREATE SEQUENCE SCOLPEDA.UE_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.EC (
    ID NUMBER(38) NOT NULL,
    LIBELLE_COURT VARCHAR2(255),
    COMP_BUDGETAIRE VARCHAR2(255),
    NOMBRE_SESSIONS NUMBER,
    DUREE_EXAMENS NUMBER,
    LANGUES VARCHAR2(255),
    PRIMARY KEY ( ID )
);
CREATE SEQUENCE SCOLPEDA.EC_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.AP (
    ID NUMBER(38) NOT NULL,
    MODEAP VARCHAR2(255),
    PRIMARY KEY ( ID ),
    CONSTRAINT FK_SCOLPEDAAP_MODE CHECK (MODEAP IN ('Présentiel', 'A distance', 'Auto formation'))
);
CREATE SEQUENCE SCOLPEDA.AP_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.CREDITABLE (
    ID NUMBER(38) NOT NULL,
    CREDIT_ECTS NUMBER,
    TRAVAIL_ETUDIANT NUMBER,
    BASE_NOTE NUMBER,
    SANS_NOTE NUMBER DEFAULT 0 NOT NULL,
    COMPOSANT_ID NUMBER(38) NOT NULL,    
    PRIMARY KEY ( ID ),
    CONSTRAINT FK_SCOLPEDACREDITABLE_CID FOREIGN KEY (COMPOSANT_ID) REFERENCES SCOLPEDA.COMPOSANT (ID)
);
CREATE SEQUENCE SCOLPEDA.CREDITABLE_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.SESSION_COMPOSANT (
    ID NUMBER(38) NOT NULL,
    ACTIVE NUMBER DEFAULT 0 NOT NULL,
    SEUIL NUMBER,
    FORMULE VARCHAR2(255),
    COMPOSANT_ID NUMBER(38) NOT NULL, 
    PRIMARY KEY ( ID ),
    CONSTRAINT FK_SCOLPEDASESSION_COMPID FOREIGN KEY (COMPOSANT_ID) REFERENCES SCOLPEDA.COMPOSANT (ID)
);
CREATE SEQUENCE SCOLPEDA.SESSION_COMPOSANT_SEQ START WITH 1;



---------- 	PARTIE HAUTE ------------
CREATE TABLE SCOLPEDA.DOMAINE (
  	ID NUMBER(38) NOT NULL,
  	CODE NUMBER(38) NOT NULL,
  	TYPE VARCHAR2(255),
  	LIBELLE VARCHAR2(255) NOT NULL,
  	PRIMARY KEY (ID)
);
CREATE SEQUENCE SCOLPEDA.DOMAINE_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.DISCIPLINE (
  	ID NUMBER(38) NOT NULL,
  	CODE NUMBER(38) NOT NULL,
  	TYPE VARCHAR2(255),
  	LIBELLE VARCHAR2(255) NOT NULL,
  	PRIMARY KEY (ID)
);
CREATE SEQUENCE SCOLPEDA.DISCIPLINE_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.ETABLISSEMENT (
  	ID NUMBER(38) NOT NULL,
  	CODE NUMBER NOT NULL,
  	NOM VARCHAR2(255) NOT NULL,
  	TYPE_PARTENARIAT VARCHAR2(255),
  	PRIMARY KEY (ID)
);
CREATE SEQUENCE SCOLPEDA.ETABLISSEMENT_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.HABILITATION (
  	ID NUMBER(38) NOT NULL,
  	ANNEE_DEBUT NUMBER NOT NULL,
  	ANNEE_FIN NUMBER NOT NULL,
  	NIVEAU_FORMATION VARCHAR2(255) NOT NULL,
  	PRIMARY KEY (ID)
);
CREATE SEQUENCE SCOLPEDA.HABILITATION_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.GRADE (
  	ID NUMBER(38) NOT NULL,
  	TYPE VARCHAR2(255) NOT NULL,
  	LIBELLE VARCHAR2(255) NOT NULL,
  	NB_UNITES_TEMPS NUMBER,
  	PRIMARY KEY (ID)
);
CREATE SEQUENCE SCOLPEDA.GRADE_SEQ START WITH 6;


CREATE TABLE SCOLPEDA.TYPE_PERIODE (
  	ID NUMBER(38) NOT NULL,
  	TYPE VARCHAR2(255) NOT NULL,
  	LIBELLE VARCHAR2(255) NOT NULL,
  	NB_PERIODES NUMBER,
  	PRIMARY KEY (ID)
);
CREATE SEQUENCE SCOLPEDA.TYPE_PERIODE_SEQ START WITH 4;


CREATE TABLE SCOLPEDA.DIPLOME (
  	ID NUMBER(38) NOT NULL,
  	SISE_MESS NUMBER(38),
  	SISE_ETABLISSEMENT NUMBER(38),
  	LIBELLE_COURT VARCHAR2(255),
  	MENTION VARCHAR2(255),
  	SPECIALITE VARCHAR2(255),
  	GRADE_ID NUMBER(38),
  	TYPE_PERIODE_ID NUMBER(38),
  	HABILITATION_ID NUMBER(38),
  	PRIMARY KEY (ID),
  	CONSTRAINT FK_SCOLPEDADIPLOME_GRADEID FOREIGN KEY (GRADE_ID) REFERENCES SCOLPEDA.GRADE (ID),
  	CONSTRAINT FK_SCOLPEDADIPLOME_TYPEPID FOREIGN KEY (TYPE_PERIODE_ID) REFERENCES SCOLPEDA.TYPE_PERIODE (ID),
  	CONSTRAINT FK_SCOLPEDADIPLOME_HABID FOREIGN KEY (HABILITATION_ID) REFERENCES SCOLPEDA.HABILITATION (ID)
);
CREATE SEQUENCE SCOLPEDA.DIPLOME_SEQ START WITH 1;


CREATE TABLE SCOLPEDA.DIPLOMES_INTERMEDIAIRE (
  	DIPLOME_PARENT_ID NUMBER(38) NOT NULL,
  	DIPLOME_INTERMEDIAIRE_ID NUMBER(38) NOT NULL,
  	PRIMARY KEY (DIPLOME_PARENT_ID, DIPLOME_INTERMEDIAIRE_ID),
  	CONSTRAINT FK_SCOLPEDADIPLOME_DPARENTID FOREIGN KEY (DIPLOME_PARENT_ID) REFERENCES SCOLPEDA.DIPLOME (ID),
  	CONSTRAINT FK_SCOLPEDADIPLOME_DINTERID FOREIGN KEY (DIPLOME_INTERMEDIAIRE_ID) REFERENCES SCOLPEDA.DIPLOME (ID)
);
